//+-----------------------------------------------------------------+
//|                                              Multiple bollinger  |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
//No trade day
#define  MONDAY         1
#define  FRIDAY         5

//Setting
extern   double   Lots = 0.01;
extern   int      Slippage = 3;
extern   int      Magicno1=0505;
extern   int      Magicno2=0508;
extern   int      BandsPeriod=20;
extern   int      BandsDeviation=2;
extern   string   C1="JPY";
extern   string   C2="USD";
extern   string   B="EUR";
extern   string   Suffix="";
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init(){
   return(0);
}

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
//----
   return(0);
  }
  
//+------------------------------------------------------------------+
//| close order                                                      |
//+------------------------------------------------------------------+
void   close_all(string c, int op, int magicno, int slip){
   int      cnt=0;
   bool     orderflg=true;
   double   balance=AccountBalance();
   while(orderflg==true){
      orderflg=false;
      for(cnt=OrdersTotal()-1;cnt>=0;cnt--){
         OrderSelect(cnt,SELECT_BY_POS);
         if(magicno!=OrderMagicNumber())continue;
         if(c!=OrderSymbol())continue;
         if(op!=OrderType())continue;
         if(OrderType()==OP_BUY){
            orderflg=true;
            OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),slip,Green);
         }else if(OrderType()==OP_SELL){
            orderflg=true;
            OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),slip,Green);
         }
      }
   }
   if(balance!=AccountBalance()){
      SendMail("[Position Closed]", "Account:"+AccountNumber()+"\n"+
                                    "Account Balance=:"+NormalizeDouble(AccountBalance(),0)+")");
   }
   return;
}


//+------------------------------------------------------------------+
//| Send order                                                       |
//+------------------------------------------------------------------+
int  sendorder(string c, int optype, double lots, int slip, double sl, double tp, string comment, int MagicNumber){
   int      ticket=0;
   int      pricemode=MODE_ASK;
   string   entrytype="Long";
   double   totallots=0;
   if(optype==OP_SELL){
      pricemode=MODE_BID;
      entrytype="Short";
   }
   ticket = OrderSend(c,optype,lots,MarketInfo(c,pricemode), slip, sl, tp, comment, MagicNumber, 0, Yellow);
   if(ticket>0) {
      OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES);
      Print("Order opened : ", OrderOpenPrice());
      SendMail("[Position Entry]",  "Account:"+AccountNumber()+"\n"+
                                    "Account Balance=:"+NormalizeDouble(AccountBalance(),0)+"\n"+
                                    "Symbol:"+ OrderSymbol() + "\n"+
                                    "Price"+DoubleToStr(OrderOpenPrice(),4)+"("+entrytype+")");
   }else{
      Print("Error opening order : ", GetLastError());
   }

   return(ticket);
}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start(){
   double   lots=Lots;//NormalizeDouble(AccountBalance()/(8*AccountLeverage()),3);
   string   bc1=B+C1+Suffix;
   string   bc2=B+C2+Suffix;
   string   c2c1=C2+C1+Suffix;
   
   double   data[1000];
   for(int i=0;i<=BandsPeriod;i++){
      data[i]=iMA(bc1,0,BandsPeriod,0,MODE_SMMA,PRICE_CLOSE,i)-
               iMA(bc2,0,BandsPeriod,0,MODE_SMMA,PRICE_CLOSE,i)*
               iMA(c2c1,0,BandsPeriod,0,MODE_SMMA,PRICE_CLOSE,i);
   }
   
   double   bc1price=iClose(bc1,0,0);
   double   bc2price=iClose(bc2,0,0);
   double   c2c1price=iClose(c2c1,0,0);
   double   bc1ma=iMA(bc1,0,BandsPeriod,0,MODE_SMMA,PRICE_CLOSE,i);
   double   bc2ma=iMA(bc2,0,BandsPeriod,0,MODE_SMMA,PRICE_CLOSE,i);
   double   c2c1ma=iMA(c2c1,0,BandsPeriod,0,MODE_SMMA,PRICE_CLOSE,i);

   ArraySetAsSeries(data,true);
   double   curgap=data[0];
   double   bollupper=iBandsOnArray(data,0,BandsPeriod,BandsDeviation,0,MODE_UPPER,1);                
   double   bolllower=iBandsOnArray(data,0,BandsPeriod,BandsDeviation,0,MODE_LOWER,1);

   //Open position status
   double   m1bc1lots=0,m2bc1lots=0,m1bc2lots=0,m2bc2lots=0,m1c2c1lots=0,m2c2c1lots=0;
   for(int cnt=0;cnt<OrdersTotal();cnt++) {
      OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if(OrderMagicNumber()==Magicno1){
         if(OrderSymbol()==bc1)m1bc1lots+=OrderLots();
         if(OrderSymbol()==bc2)m1bc2lots+=OrderLots();
         if(OrderSymbol()==c2c1)m1c2c1lots+=OrderLots();
      }else if(OrderMagicNumber()==Magicno2){
         if(OrderSymbol()==bc1)m2bc1lots+=OrderLots();
         if(OrderSymbol()==bc2)m2bc2lots+=OrderLots();
         if(OrderSymbol()==c2c1)m2c2c1lots+=OrderLots();
      }
   }

   if(curgap>bollupper){
      if(bc1price>bc1ma){
         if(m1bc1lots==0)sendorder(bc1,OP_SELL,lots,Slippage,0,0,"",Magicno1);
         close_all(Symbol(),OP_BUY,Magicno2,Slippage);
      }
      if(bc2price<bc2ma){
         if(m1bc2lots==0)sendorder(bc2,OP_BUY,lots,Slippage,0,0,"",Magicno1);
         close_all(bc2,OP_SELL,Magicno2,Slippage);
      }
      if(c2c1price<c2c1ma){
         if(m1c2c1lots==0)sendorder(c2c1,OP_BUY,lots,Slippage,0,0,"",Magicno1);
         close_all(Symbol(),OP_SELL,Magicno2,Slippage);
      }
  }else if(curgap<bolllower){
      if(bc1price<bc1ma){
         if(m2bc1lots==0)sendorder(bc1,OP_BUY,lots,Slippage,0,0,"",Magicno2);
         close_all(Symbol(),OP_SELL,Magicno1,Slippage);
      }
      if(bc2price>bc2ma){
         if(m2bc2lots==0)sendorder(bc2,OP_SELL,lots,Slippage,0,0,"",Magicno2);
         close_all(bc2,OP_BUY,Magicno1,Slippage);
      }
      if(c2c1price>c2c1ma){
         if(m2c2c1lots==0)sendorder(c2c1,OP_SELL,lots,Slippage,0,0,"",Magicno2);
         close_all(Symbol(),OP_BUY,Magicno1,Slippage);
      }
  }
  return(0);
}

